      16C74
      NOSYMTAB
include regs73.inc
include tal_data.inc


      CODE
      org   0
      movlw high Reset
      movwf PCLATH
      goto  Reset

      org   4
;      nop
      goto  Interrupt

      org   8
Reset:
;      nop
      goto  Start

      org   16
;REPT  2F0h
;      nop
;ENDR

Interrupt:; 2*Nint+11 横, Nint-᫮ ࠡ稪
      movwf tmpW
      swapf STATUS,0
      bcf   STATUS,rbRP0
      movwf tmpStatus

      btfsc PIR1,rbTMR2IF
      call  IntTimer
      btfsc PIR1,rbCCP1IF
      call  IntMotor

      swapf tmpStatus,0
      movwf STATUS
      swapf tmpW,1
      swapf tmpW,0
      retfie

IntTimer PROC; 500Hz
      decfsz Cnt10ms,1
      goto  IntTimerE
      movlw 5; 100Hz
      movwf Cnt10ms
      bsf   fTimer
IntTimerE:
      bcf   PIR1,rbTMR2IF
      return
ENDP

IntMotor PROC
      btfsc fChSpeed
      goto  IntMotor0
      movf  CurrentSpeed+1,0
      movwf CCPR1+1
      movf  CurrentSpeed,0
      movwf CCPR1
IntMotor0:

      btfss fGo
      goto  IntMotorE

      decf  StepCounter,0
      btfsc fRevers
      goto  IntMotor1
      incf  StepCounter,0
IntMotor1:
      andlw 7
      movwf StepCounter

      addlw StepCodes
      movwf FSR
      movf  INDF,0
      movwf PORTC

IntMotorE:
      bcf   PIR1,rbCCP1IF
      return
ENDP

; 室: tabOffs - ᬥ饭  ⠡, tabPage - ࠭ ⠡
; 室: W - 祭, PCLATH=tabPage
; 頥 뢠 !
GoTable PROC
      bcf   INTCON,rbGIE
      btfsc INTCON,rbGIE
      goto  GoTable
      movf  tabPage,0
      movwf PCLATH
      movf  tabOffs,0
      movwf PCL
ENDP

Start:
; ன ⮢
      movlw 00010000b
      movwf PORTA
      clrf  PORTB
      clrf  PORTC

      bsf   STATUS,rbRP0; bank1

      movlw 00000001b
      movwf TRISA
      clrf  TRISC
      bcf   OPTION,rbRBPU
; ன 室 
      movlw 100b
      movwf ADCON1
; ன ⠩஢
      movlw 249
      movwf PR2; 500  (post:10, 5MHz)

      bcf   STATUS,rbRP0; bank0

      clrf  TMR2
      movlw rmTMR2ON+(9 shl rbT2OUTPS); post:10
      movwf T2CON

      clrf  TMR1
      clrf  TMR1+1
      movlw rmTMR1ON+(01b shl rbT1CKPS); pre:2
      movwf T1CON
      movlw high StarSpeed
      movwf CCPR1+1
      movlw low StarSpeed
      movwf CCPR1
      movlw 1011b; reset Tmr1 on compare
      movwf CCP1CON


; ன 
      movlw rmADON+rmADCS8; 1.6  (4 )
      movwf ADCON0

;⪠ ६
      clrf  Flags

      movlw 0001b
      movwf StepCodes
      movlw 0011b
      movwf StepCodes+1
      movlw 0010b
      movwf StepCodes+2
      movlw 0110b
      movwf StepCodes+3
      movlw 0100b
      movwf StepCodes+4
      movlw 1100b
      movwf StepCodes+5
      movlw 1000b
      movwf StepCodes+6
      movlw 1001b
      movwf StepCodes+7

      clrf  StepCounter

      movlw 5
      movwf Cnt10ms

      movlw high StarSpeed
      movwf CurrentSpeed+1
      movlw low StarSpeed
      movwf CurrentSpeed

      clrf  SpeedStep

;ன  ࠧ襭 뢠
      bsf   STATUS,rbRP0; bank1
      bsf   PIE1,rbTMR2IF
      bsf   PIE1,rbCCP1IF
      movlw rmPEIE+rmGIE
      movwf INTCON
      bcf   STATUS,rbRP0; bank0

; 横
MainLoop:
      btfss fTimer
      goto  MainLoop
      bcf   fTimer
;100Hz
      movf  PORTB,0
      movwf TmpMain
      movf  SpeedStep,1
      btfss STATUS,rbZ
      goto  FastMode
; ० ᫥
      btfsc TmpMain,kbFF
      goto  SlowMode1
      ;᪮.।
      bcf   fRevers
      incf  SpeedStep,1
      goto  SlowModeE
SlowMode1:
      btfsc TmpMain,kbFB
      goto  SlowMode2
      ;᪮.
      bsf   fRevers
      incf  SpeedStep,1
      goto  SlowModeE
SlowMode2:
      btfsc TmpMain,kbF
      goto  SlowMode4
      btfsc TmpMain,kbB
      goto  SlowMode3
      ;। + 
      bcf   fRevers
      bsf   fChSpeed
      movlw high StarSpeed
      movwf CurrentSpeed+1
      movlw low StarSpeed
      movwf CurrentSpeed
      bcf   fChSpeed
      goto  SlowModeE
SlowMode3:
      ;।
      bcf   fRevers
      bsf   fChSpeed
      movlw high FSpeed
      movwf CurrentSpeed+1
      movlw low FSpeed
      movwf CurrentSpeed
      bcf   fChSpeed
      goto  SlowModeE
SlowMode4:
      btfsc TmpMain,kbB
      goto  SlowMode5
      ;
      bcf   fRevers
      bsf   fChSpeed
      movlw high BSpeed
      movwf CurrentSpeed+1
      movlw low BSpeed
      movwf CurrentSpeed
      bcf   fChSpeed
      goto  SlowModeE
SlowMode5:
      ;  
      btfsc TmpMain,kbGen
      goto  SlowMode6
      ;
      bcf   fRevers
      bsf   fChSpeed
      movlw high StarSpeed
      movwf CurrentSpeed+1
      movlw low StarSpeed
      movwf CurrentSpeed
      bcf   fChSpeed
      goto  SlowModeE
SlowMode6:
      btfsc TmpMain,kbAuto
      goto  SlowMode7
      ;
      bcf   fRevers
      bsf   ADCON0,rbADGO
ADCStart:
      btfsc ADCON0,rbADGO
      goto  ADCStart
      movf  ADRES,0
      ;롮ઠ ᪮
      movwf tabOffs

      movlw high LoAuto
      movwf tabPage
      call  GoTable;  뢠
      movwf TmpMain
      movlw HIGH GoTable
      movwf PCLATH
      bsf   INTCON,rbGIE; ࠧ襭 뢠

      movlw high HiAuto
      movwf tabPage
      call  GoTable;  뢠
;      bsf   fChSpeed
      movwf CurrentSpeed+1
      movf  TmpMain,0
      movwf CurrentSpeed
;      bcf   fChSpeed
      movlw HIGH GoTable
      movwf PCLATH
      bsf   INTCON,rbGIE; ࠧ襭 뢠
      goto  SlowModeE
SlowMode7:
      ;stop
      bcf   fGo
      clrf  PORTC
      goto  MainLoop
SlowModeE:
      bsf   fGo
      goto  MainLoop

FastMode:
; ० ᪮७
      btfss fRevers
      goto  FastMode1
      rrf   TmpMain,1
      rrf   TmpMain,1
FastMode1:; forvard
      btfsc TmpMain,kbFF
      goto  FastMode2
      ;᪮७
      incfsz SpeedStep,0
      incf   SpeedStep,1
      goto  FastModeE
FastMode2:
      btfss TmpMain,kbF
      goto  FastModeE
      ;
      incf   SpeedStep,1
      decfsz SpeedStep,1
      decf   SpeedStep,1
FastModeE:
      ;롮ઠ ᪮
      movf  SpeedStep,0
      movwf tabOffs

      movlw high LoFast
      movwf tabPage
      call  GoTable;  뢠
      movwf TmpMain
      movlw HIGH GoTable
      movwf PCLATH
      bsf   INTCON,rbGIE; ࠧ襭 뢠

      movlw high HiFast
      movwf tabPage
      call  GoTable;  뢠
;      bsf   fChSpeed
      movwf CurrentSpeed+1
      movf  TmpMain,0
      movwf CurrentSpeed
;      bcf   fChSpeed
      movlw HIGH GoTable
      movwf PCLATH
      bsf   INTCON,rbGIE; ࠧ襭 뢠

      goto  MainLoop

include tal_tab.inc

